package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;

public class AtualizarDataReferenciaCustosPage extends PageBase {
    By clicaMenu = By.xpath("//*[@type = 'button']");
    By Inicio = By.xpath("//*[@class = 'navbar-brand zh-header-title has-header-info']");
    By buscaTela = By.xpath("/html/body/span/section/section/div[2]/section[1]/div/aside/div[1]/section/input");
    By clicarTela = By.xpath("/html/body/span/section/section/div[2]/section[1]/div/aside/div[2]/nav/ul/li/span/span[2]");
    By confirmaAcessoTela = By.xpath("//div[@class = 'navbar-header']//div[@class = 'navbar-brand zh-header-title has-header-info']");
    By buscaAgrupamento = By.xpath("//div[@id = 'NMGRUPFILI']//span[@zh-icon='no-border search']");
    By selecionaAgrupamento = By.xpath("//span[text() = '0000000001']");
    By chekBoxTodasUnidades = By.xpath("//label[@for = 'zh-checkbox-CHECK_NMFILIAL']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By campoUnidade = By.xpath("//div[@name = 'NMFILIAL']");
    By insereInformacaoBusca = By.xpath("//input[@class = 'mousetrap zh-input-search-floating ng-pristine ng-valid ng-touched']");
    By selecionaUnidade = By.xpath("//div[@class = 'body-content']//div[@class = 'td grid-checkbox-column zh-side-column fixed zh-ripple-effect']");
    By selecionaTodasUnidades = By.xpath("//*[@id='grid-9999']/div[1]/div/div/div[1]/div");
    By desmarcaUnidadeTres = By.xpath("//*[@id='grid-9999']/div[2]/div/div[2]/div[1]");
    By btnOk = By.xpath("//div[@id = 'footer']//span[text() = 'Ok']");
    By checkBoxTodosServicos = By.xpath("//label[@for = 'zh-checkbox-CHECK_NMSERVICO']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By validaCheckBoxUnidade = By.xpath("//*[@id='zh-checkbox-CHECK_NMFILIAL']");
    By validaCheckBoxServico = By.xpath("//input[@name = 'CHECK_NMSERVICO']");
    By campoServicos = By.xpath("//div[@class = 'zh-select-multiple mousetrap zh-field-NMSERVICO zh-text-align-left']");
    By selecionaServico = By.xpath("//div[@class = 'body-content']//div[@class = 'td grid-checkbox-column zh-side-column fixed zh-ripple-effect']");
    By limpaMes = By.xpath("//div[@class = 'zh-select-multiple zh-field-MES zh-text-align-left']//span[@zh-icon='no-border close-x']");
    By selecionaMes = By.xpath("//div[@class = 'month']//div[text() = 'Fev']");
    By buscaTipoCusto = By.xpath("//div[@class = 'zh-select-multiple zh-select-autocomplete mousetrap zh-field-NMTIPOCUSTO zh-text-align-left']//span[@zh-icon='no-border search']");
    By selecionaTipoCusto = By.xpath("//*[@id='popup']/span/section/section/section/div/div[1]/ul/li[2]/div/div");
    By limpaDataReferencia = By.xpath("//div[@class = 'zh-select-date zh-field-DTREF']//span[@zh-icon='no-border close-x']");
    By botaoCalendario = By.xpath("//span[@zh-icon='no-border calendar']");
    By calendarioDataReferencia = By.xpath("//div[@class = 'zh-select-date zh-field-DTREF']//span[@zh-icon='no-border calendar']");
    By diaDataReferencia = By.xpath("//div[@class = 'day today']");
    By btnConfirmar = By.xpath("//span[text() = 'Confirmar']");
    By alertMensagemOk = By.xpath("//button[@class = 'zh-alert-button']");
    By confirmaMensagem = By.xpath("//button[@data-ng-repeat='button in buttons']//span[text() = 'Sim']");
    By periodoAnterior = By.xpath("//div[@class = 'arrow-left zh-icon zh-icon-previous zh-icon-no-border']");
    By mesDezembro = By.xpath("//div[@class = 'month']//div[text() = 'Dez']");
    By botaoOk = By.xpath("//footer[@class = 'zh-footer-alert']//button[@class = 'zh-alert-button']");

    //Campos do botão de pesquisa
    By botaoAbrirOpcoesControleTelaInicial = By.xpath("//div[@data-ng-if='widget.isFloatingControlVisible()']//div[@data-zh-floating-control]");
    By botaoPesquisarFiltro = By.xpath("//div[@class='control-menu']//li[@data-zh-id='zh-floating-control-custom-action-1']");
    By campoProcurar = By.xpath("//li[@class='float-action expandable fix-position-bottom opened']//input[@placeholder='Procurar']");

    //Campos Obrigatorios
    By msgEncontradaUnidade = By.xpath("//div[@data-zh-id='147172017134643103021206']//div[2]//span[1]");
    By msgEncontradaServico = By.xpath("//div[@data-zh-id='14717201719481286801213']//div[2]//span[1]");
    By msgEncontradaMes = By.xpath("//div[@data-zh-id='14717201715345848101220']//div[2]//span[1]");
    By msgEncontradaCusto = By.xpath("//div[@data-zh-id='14717201711557115132231']//div[2]//span[1]");
    By msgEncontradaDtRef = By.xpath("//div[@data-zh-id='147172017124034535981221']//div[2]//span[1]");


    public void acessaTelaAtualizaDataReferencia(){
        tempo();
        click(clicaMenu);
        tempo();
        click(buscaTela);
        clearAndSendKeys(buscaTela,"Atualizar Data de Referência para Custos");
        tempo();
        click(clicarTela);
        tempo();
    }

    public void atualizaCustoDataAnteriorProc(String CDFILIAL){
        tempo();
        click(buscaAgrupamento);
        tempo();
        click(selecionaAgrupamento);
        tempo();
        click(chekBoxTodasUnidades);
        click(campoUnidade);
        tempo();
        click(insereInformacaoBusca);
        sendKeys(insereInformacaoBusca,CDFILIAL);
        tempo();
        click(selecionaUnidade);
        click(btnOk);
        tempo();
        click(checkBoxTodosServicos);
        click(campoServicos);
        tempo();
        click(insereInformacaoBusca);
        sendKeys(insereInformacaoBusca,"00002");
        tempo();
        click(selecionaServico);
        click(btnOk);
        tempo();
        click(limpaMes);
        click(botaoCalendario);
        tempo();
        click(selecionaMes);
        tempo();
        click(buscaTipoCusto);
        tempo();
        preencherCampoProcurarTelaInicial(botaoAbrirOpcoesControleTelaInicial,botaoPesquisarFiltro,campoProcurar,"Custo Médio Bruto da Época");
        tempo();
        click(selecionaTipoCusto);
        tempo();
        click(limpaDataReferencia);
        click(calendarioDataReferencia);
        tempo();
        click(diaDataReferencia);
        tempo();
        click(btnConfirmar);
        tempo();
        click(botaoOk);
        tempo();
    }

    public void atualizaCustoDataReferenciaUnidade(String CDFILIAL, String CDSERVFILI){
        tempo();
        if (returnIfElementIsSelected(validaCheckBoxUnidade)){
            click(chekBoxTodasUnidades);
            click(campoUnidade);
        }else{
            click(campoUnidade);
        }
        tempo();
        preencherCampoProcurarTelaInicial(botaoAbrirOpcoesControleTelaInicial,botaoPesquisarFiltro,campoProcurar,CDFILIAL);
        tempo();
        click(selecionaUnidade);
        click(btnOk);
        tempo();
        if (returnIfElementIsSelected(validaCheckBoxServico)){
            click(checkBoxTodosServicos);
            click(campoServicos);
        }else{
            click(campoServicos);
        }
        preencherCampoProcurarTelaInicial(botaoAbrirOpcoesControleTelaInicial,botaoPesquisarFiltro,campoProcurar,CDSERVFILI);
        tempo();
        click(selecionaServico);
        click(btnOk);
        tempo();
        click(limpaMes);
        click(botaoCalendario);
        tempo();
        click(mesDezembro);
        tempo();
        click(buscaTipoCusto);
        tempo();
        preencherCampoProcurarTelaInicial(botaoAbrirOpcoesControleTelaInicial,botaoPesquisarFiltro,campoProcurar,"Custo Médio Bruto da Época");
        tempo();
        click(selecionaTipoCusto);
        tempo();
        click(limpaDataReferencia);
        click(calendarioDataReferencia);
        tempo();
        click(diaDataReferencia);
        click(btnConfirmar);
        tempo();
        click(botaoOk);
        tempo();

    }

    public void atualizaCustoDataReferencuaTodos(){
        tempo();
        if (returnIfElementIsSelected(validaCheckBoxUnidade)){
            click(chekBoxTodasUnidades);
            click(campoUnidade);
        }else{
            click(campoUnidade);
        }
        tempo();
        click(selecionaTodasUnidades);
        click(desmarcaUnidadeTres);
        click(btnOk);

        if (!returnIfElementIsSelected(validaCheckBoxServico)) {
            click(checkBoxTodosServicos);
        }
        tempo();
        click(limpaMes);
        click(botaoCalendario);
        tempo();
        click(mesDezembro);
        tempo();
        click(buscaTipoCusto);
        tempo();
        preencherCampoProcurarTelaInicial(botaoAbrirOpcoesControleTelaInicial,botaoPesquisarFiltro,campoProcurar,"Custo Médio Bruto da Época");
        tempo();
        click(selecionaTipoCusto);
        tempo();
        click(limpaDataReferencia);
        click(calendarioDataReferencia);
        tempo();
        click(diaDataReferencia);
        click(btnConfirmar);
        tempo();
        click(confirmaMensagem);
        tempo();
    }

    public void atualizaCustoDataReferencuaAgrupamento(){
        click(buscaAgrupamento);
        tempo();
        click(selecionaAgrupamento);
        tempo();
        if (returnIfElementIsSelected(validaCheckBoxUnidade)){
            click(chekBoxTodasUnidades);
            click(campoUnidade);
        }else{
            click(campoUnidade);
        }
        tempo();
        preencherCampoProcurarTelaInicial(botaoAbrirOpcoesControleTelaInicial,botaoPesquisarFiltro,campoProcurar,"0002");
        tempo();
        click(selecionaUnidade);
        click(btnOk);
        tempo();
        if (returnIfElementIsSelected(validaCheckBoxServico)){
            click(checkBoxTodosServicos);
            click(campoServicos);
        }else{
            click(campoServicos);
        }
        preencherCampoProcurarTelaInicial(botaoAbrirOpcoesControleTelaInicial,botaoPesquisarFiltro,campoProcurar,"00002");
        tempo();
        click(selecionaServico);
        click(btnOk);
        tempo();
        click(limpaMes);
        click(botaoCalendario);
        tempo();
        click(mesDezembro);
        tempo();
        click(buscaTipoCusto);
        tempo();
        preencherCampoProcurarTelaInicial(botaoAbrirOpcoesControleTelaInicial,botaoPesquisarFiltro,campoProcurar,"Custo Médio Bruto da Época");
        tempo();
        click(selecionaTipoCusto);
        tempo();
        click(limpaDataReferencia);
        click(calendarioDataReferencia);
        tempo();
        click(diaDataReferencia);
        click(btnConfirmar);
        tempo();
        click(confirmaMensagem);
        tempo();


    }

    public void validarCamposObrigatorios(){
        tempo();
        if (returnIfElementIsSelected(validaCheckBoxUnidade)){
            click(chekBoxTodasUnidades);
        }

        if (returnIfElementIsSelected(validaCheckBoxServico)){
            click(checkBoxTodosServicos);
        }
        tempo();
        click(limpaMes);
        tempo();
        click(limpaDataReferencia);
        click(btnConfirmar);
        tempo();
    }

    public String campoObrigatorioUnidade(){
        return getText(msgEncontradaUnidade);
    }

    public String campoObrigatorioServico(){
        return getText(msgEncontradaServico);
    }

    public String campoObrigatorioMes(){
        return getText(msgEncontradaMes);
    }

    public String campoObrigatorioCusto(){
        return getText(msgEncontradaCusto);
    }

    public String campoObtigatorioDtRef(){
        return getText(msgEncontradaDtRef);
    }


}
